import { getChromeStorage, setChromeStorage } from '../uilts/chromeExtension.js'
import { getTtwitterRequestToken, twitterLogin } from '../server/twitter.js'

export function contentTwitterPinLogin(port) {
    if (window.location.href == 'https://api.twitter.com/oauth/authorize') {
        let code = document.querySelector('code')

        if (code) {
            port.postMessage({ state: 'CONTENT_SEND_CODE', code: code.innerText })
        }
    }
}
export function contentAddButton(port) {
    let button = document.querySelector('input')
    button.type = 'button'
    button.value = '123123'
    button.id = 'id123'
    button.onclick = () => {
        port.postMessage({ state: 'CONTENT_TWITTER_LOGIN' })
    }
    document.body.appendChild(button)
}

let authToken = ''
export function backTwitterPinLoginToken() {
    // 1.判断是否登陆了
    getChromeStorage('userInfo', (res) => {
        // 没有登陆
        if (!res) {
            getTtwitterRequestToken().then((res) => {
                authToken = res.data.authToken
                chrome.tabs.create({
                    url: `https://api.twitter.com/oauth/authorize?oauth_token=${res.data.authToken}`
                })
            })
        }
    })
}

export function backTwitterPinLoginCode(code) {
    // 关闭code页面
    chrome.tabs.query({}, (tab) => {
        for (let i in tab) {
            console.log(tab[i])
            if (tab[i].url == 'https://api.twitter.com/oauth/authorize') {
                chrome.tabs.remove(tab[i].id)
            }
        }
    })
    // 发送请求
    // token,code
    twitterLogin(authToken, code).then(res => {
        if (res.code == 0) {
            setChromeStorage({ userInfo: JSON.stringify(res.data) })
        }
    })
}


function parseDOMRedPacket() {
    let denet_arr = document.querySelector('article[data-testid=tweet]').querySelectorAll('a')
    let _dom = null
    for (let i in denet_arr) {
        if (denet_arr[i].innerText == '#denet') {
            _dom = denet_arr[i].parentNode.parentNode.parentNode.parentNode.children[1]
            // 是否有有红包秘文
        }
    }
    console.log(_dom)
    return _dom
}

function replaceDOMRedPacket(_dom) {
    if (!_dom || _dom.querySelector('iframe')) {
        return
    }
    let _iframe = document.createElement('iframe')
    _iframe.src = chrome.runtime.getURL('/iframe/red-packet.html');
    _dom.appendChild(_iframe)
}


export function setIframeRedPacket() {
    // if(window.location.href != 'https://twitter.com/home'){
    //     return
    // }

    document.addEventListener('scroll', () => {
        console.log(1)
        
        // 1.解析推文
        // 2.替换推文
        replaceDOMRedPacket(parseDOMRedPacket())
    })


}
